1000 REMark --------------------------------------------------
1005 REMark *** Create a program to rebuild directory tree ***
1010 REMark *** Copyright - Norman Dunbar                  ***
1015 REMark ***             January 1992.                  ***
1020 REMark --------------------------------------------------
1025 :
1030 WHEN_ERROR 0
1035   CONTINUE
1040 END_WHEN
1045 :
1050 init
1055 PRINT 'Enter the device name to hold the generated program'
1060 PRINT 'Press ENTER only to quit : ';
1065 device$ = EDIT$(device$, 5)
1070 IF device$ = '' THEN STOP: END IF 
1075 DELETE device$ & 'make_directory_tree_bas'
1080 OPEN_NEW #3,device$ & 'make_directory_tree_bas'
1085 generate_first_part
1090 PRINT \\'Press ESC to abort ..........'\\
1095 PRINT 'The following directories have been detected ...'\\
1100 check_dir 'win1_'
1105 CLOSE #3
1110 PRINT
1115 PRINT \\'Program "' & device$ & 'make_directory_tree_bas" has been ';
1120 PRINT 'generated.'
1125 STOP
1130 :
1135 :
1140 DEFine PROCedure check_dir (d$)
1145   LOCal name_len%, curr_d$(40), curr_f$(41), entry$(64), loop
1150   LOCal ch%, qdos, err_loop, error_code%, loop_yn
1155   :
1160   curr_d$ = d$
1165   CURSOR_ON #1 !
1170   REPeat err_loop
1175      qdos = FOPEN_DIRECTORY(curr_d$)
1180      IF qdos < 0
1185         FORCE_ERROR qdos, 'Cannot open directory on ' & curr_d$
1190      ELSE 
1195         EXIT err_loop
1200      END IF 
1205   END REPeat err_loop
1210   REPeat loop
1215     IF END_OF_DIRECTORY(qdos) THEN EXIT loop: END IF 
1220     IF INKEY$(#1, 2) = CHR$(27)
1225        aborted = 1:    REMark ** ESC pressed during processing **
1230        EXIT loop
1235     END IF 
1240     entry$ = FREAD_DIRECTORY$(qdos)
1245     IF entry$ = '' THEN NEXT loop: END IF 
1250     name_len% = CODE(entry$(15)) * 256 + CODE(entry$(16))
1255     IF NOT (name_len%) THEN NEXT loop: END IF 
1260     curr_f$ = entry$(17 TO (17 + name_len% - 1))
1265     IF CODE(entry$(6)) = 255
1270        PRINT ! curr_f$ !
1275        PRINT #3,next_line% & ' DATA "' & curr_f$ & '"'
1280        next_line% = next_line% + 5
1285        check_dir ('win1_' & curr_f$)
1290        IF aborted THEN EXIT loop: END IF 
1295     END IF 
1300   END REPeat loop
1305   CLOSE_DIRECTORY (qdos)
1310   CURSOR_OFF #1
1315 END DEFine check_dir
1320 :
1325 :
1330 DEFine PROCedure FORCE_ERROR (error_code, text$)
1335   PRINT #1, 'Error ' & error_code
1340   PRINT #1, text$
1345   PRINT_ERROR$ #1, error_code
1350   STOP
1355 END DEFine FORCE_ERROR
1360 :
1365 :
1370 DEFine PROCedure init
1375   DATA_AREA 6
1380   aborted = 0:          REMark ** If ESC pressed during processing **
1385   next_line% = 1500
1390   DIM yn$(1)
1395   DIM device$(5)
1400   device$ = 'flp1_'
1405   IF COMPILED
1410      OPEN #2,'scr_448x22a32x16'
1415      PAPER #2, 6: CLS #2
1420      INK #2, 6: PAPER #2, 2: CLS #2: BORDER #2, 1, 1
1425      OPEN #1, 'con_448x178a32x38'
1430      INK #1, 0: PAPER #1, 4: CLS #1: BORDER #1, 1, 1
1435      CSIZE #2, 0, 1
1440      PRINT #2,FILL$(' ', 20);
1445      PRINT #2, 'MAKE DIRECTORY TREE (c) Norman Dunbar';
1450      CSIZE #2, 0, 0
1455   END IF 
1460   CURSOR_ON #1 !
1465 END DEFine 
1470 :
1475 :
1480 DEFine PROCedure generate_first_part
1485   LOCal a_line$(80), loop
1490   RESTORE 
1495   REPeat loop
1500     IF EOF THEN EXIT loop: END IF 
1505     READ a_line$
1510     PRINT #3,a_line$
1515   END REPeat loop
1520   :
1525   :
1530   DATA "1000 REMark **===========================**"
1535   DATA "1010 REMark ** Directory rebuild utility **"
1540   DATA "1020 REMark **    Created by WinBack     **"
1545   DATA "1030 REMark ** Copyright - Norman Dunbar **"
1550   DATA "1040 REMark **===========================**"
1555   DATA "1050 :"
1560   DATA "1060 :"
1565   DATA "1070 CLS"
1570   DATA "1080 RESTORE "
1575   DATA "1090 PRINT 'Rebuilding hard disc directory structure'"
1580   DATA "1100 PRINT '========================================'"
1585   DATA "1110 PRINT"
1590   DATA "1120 REPeat loop"
1595   DATA "1130   IF EOF THEN EXIT loop: END IF "
1600   DATA "1140   READ d$"
1605   DATA "1150   PRINT 'Creating ' & d$;"
1610   DATA "1160   MAKE_DIR 'win1_' & d$"
1615   DATA "1170   PRINT ', created.'"
1620   DATA "1180 END REPeat loop"
1625   DATA "1190 :"
1630   DATA "1200 :"
1635 END DEFine generate_first_part
